searchNodes=[{"doc":"A Plug that caches HTTP responses This plug library relies on the http_cache library. It supports all caching features of RFC9111 and more (such as conditional requests and range requests). See http_cache documentation for more information. Configuration In your plug pipeline, set the Plug for routes on which you want to enable caching: router.ex pipeline :cache do plug PlugHTTPCache , @caching_options end ... scope &quot;/&quot; , PlugHTTPCacheDemoWeb do pipe_through :browser scope &quot;/some_route&quot; do pipe_through :cache ... end end You can also configure it for all requests by setting it in Phoenix's endpoint file: endpoint.ex defmodule MyApp.Endpoint do use Phoenix.Endpoint , otp_app : :plug_http_cache_demo % some other plugs plug Plug.RequestId plug Plug.Telemetry , event_prefix : [ :phoenix , :endpoint ] plug Plug.Parsers , parsers : [ :urlencoded , :multipart , :json ] , pass : [ &quot;*/*&quot; ] , json_decoder : Phoenix . json_library ( ) plug Plug.Head plug Plug.Session , @session_options plug PlugHTTPCache , @caching_options plug PlugHTTPCacheDemoWeb.Router end Note that: caching chunked responses is not supported some responses (called &quot;cacheable by default&quot;) can be cached even when no cache-control header is set. For instance, a 200 response to a get request is cached 2 minutes by default, unless cache-control headers prohibit it Phoenix automatically sets the &quot;cache-control&quot; header to &quot;max-age=0, private, must-revalidate&quot; , so by default no response will ever be cached unless you override this header You can also configure PlugHTTPCache.StaleIfError to return expired cached responses. This is useful to continue returning something when the backend experiences failures (for example if the DB crashed and while it's rebooting). Plug options Plug options are those documented by :http_cache.opts/0 . The only required option is :store . This plug sets the following default options: :type : :shared , :auto_compress : true , :auto_accept_encoding : true Stores Responses have to be stored in a separate store backend (this library does not come with one), such as: http_cache_store_memory : responses are stored in memory (ETS) http_cache_store_disk : responses are stored on disk. An application using the sendfile system call (such as plug_http_cache ) may benefit from the kernel's memory caching automatically Both are cluster-aware. To use it along with this library, just add it to your mix.exs file: mix.exs { :plug_http_cache , &quot;~&gt; ...&quot; } , { :http_cache_store_memory , &quot;~&gt; ...&quot; } , Security considerations Unlike many HTTP caches, http_cache allows caching: responses to authorized request (with an &quot;authorization&quot; header) responses with cookies In the first case, beware of authenticating before handling caching. In other words, don't : PlugHTTPCache , @caching_options MyPlug.AuthorizeUser which would return a cached response to unauthorized users, but do instead: MyPlug.AuthorizeUser PlugHTTPCache , @caching_options Beware of not setting caching headers on private responses containing cookies. Useful libraries PlugCacheControl can be used to set cache-control headers in your Plug pipelines, or manually in your controllers PlugHTTPValidator should be used to set HTTP validators as soon as cacheable content is returned. See project documentation to figure out why Telemetry events The following events are emitted: [:plug_http_cache, :hit] when a cached response is returned. [:plug_http_cache, :miss] when no cached response was found [:plug_http_cache, :stale_if_error] when a response was returned because an error occurred downstream (see PlugHTTPCache.StaleIfError ) Neither measurements nor metadata are added to these events. The http_cache , http_cache_store_memory and http_cache_store_disk emit other events about the caching subsystems, including some helping with detecting normalization issues. Normalization The underlying http caching library may store different responses for the same URL, following the directives of the &quot;vary&quot; header. For instance, if a response can be returned in English or in French, both versions can be cached as long as the &quot;vary&quot; header is correctly used. This can unfortunately result in an explosion of stored responses if the headers are not normalized. For instance, in this scenario where a site handles both these languages, a response will be stored for any of these requests that include an &quot;accept-language&quot; header: fr-CH, fr;q=0.9, en;q=0.8, de;q=0.7, *;q=0.5 fr-CH, fr;q=0.9, en;q=0.8, de;q=0.7,*;q=0.5 en de en, de en, de, fr en;q=1, de en;q=1, de;q=0.9 en;q=1, de;q=0.8 en;q=1, de;q=0.7 en;q=1, de;q=0.6 en;q=1, de;q=0.5 and so on, so potentially hundreds of stored responses for only 2 available responses (English and French versions). In this case, you probably want to apply normalization before caching. This could be done by a plug set before the PlugHTTPCache plug. See Best practices for using the Vary header for more guidance regarding this issue.","ref":"PlugHTTPCache.html","title":"PlugHTTPCache","type":"module"},{"doc":"Adds one or more alternate keys to the cached response Request with alternate keys can be later be invalidated with the :http_cache.invalidate_by_alternate_key/2 function.","ref":"PlugHTTPCache.html#set_alternate_keys/2","title":"PlugHTTPCache.set_alternate_keys/2","type":"function"},{"doc":"Return stale entries when backend fails This module can help returning stale responses when the backend is temporarily unusable (for instance when restarting the DB) or when some unexpected errors occur. One of this known errors by Elixir developers is the ** (DBConnection.ConnectionError) connection not available and request was dropped from queue after 2655ms. This means requests are coming in and your connection pool cannot serve them fast enough. You can address this by: 1 . By tracking down slow queries and making sure they are running fast enough 2 . Increasing the pool_size ( albeit it increases resource consumption ) 3 . Allow requests to wait longer by increasing :queue_target and :queue_interval See DBConnection . start_link / 2 for more information ecto errors which occur when it is under intense stress. Whenever a fresh response is found, it is returned by the PlugHTTPCache plug. Stale responses, however, aren't. Stale responses are those whose expiration has been reached but are still keep in the cache until the grace period is expired. By default, the http_cache library caches cacheable responses 2 minutes, and keep them 2 more minutes (which is called the grace period ). By setting this module in your plug pipeline, a stale response can be returned whenever an exception is raised by the backend by adding this at the beginning of the router: use PlugHTTPCache.StaleIfError , ... % same options as when using ` PlugHTTPCache ` When using it jointly with Plug.ErrorHandler , you should add it before: use PlugHTTPCache.StaleIfError , ... % same options as when using ` PlugHTTPCache ` use Plug.ErrorHandler so that it is called before Plug.ErrorHandler 's generic error handling. In this case, if a stale response if found, it is returned. Otherwise, the error handler of Plug.ErrorHandler is called. Staled responses are returned only when the &quot;stale-if-error&quot; cache control directive is used, either in the request or in the response. As very few clients use it, you probably want to use it server side by setting this directive before returning the response in your controllers: conn |&gt; put_resp_header ( &quot;cache-control&quot; , &quot;stale-if-error=600&quot; ) ... One can also not &quot;cache&quot; response, but still keep staled versions to keep some pages showing even in case of serious trouble on the backend: conn |&gt; put_resp_header ( &quot;cache-control&quot; , &quot;max-age=0, stale-if-error=600&quot; ) ... Such a response will not be reused except by this module, in case of error. Note that as with the Plug.ErrorHandler module, error is reraised in any case.","ref":"PlugHTTPCache.StaleIfError.html","title":"PlugHTTPCache.StaleIfError","type":"module"},{"doc":"A Plug that caches HTTP responses This plug library relies on the http_cache library. It supports all caching features of RFC9111 and more (such as conditional requests and range requests). See http_cache documentation for more information. Screenshot from the plug_http_cache_demo application.","ref":"readme.html","title":"PlugHTTPCache","type":"extras"},{"doc":"def deps do [ { :http_cache , &quot;~&gt; 0.3.0&quot; } { :plug_http_cache , &quot;~&gt; 0.3.0&quot; } ] end","ref":"readme.html#installation","title":"PlugHTTPCache - Installation","type":"extras"},{"doc":"In your plug pipeline, set the Plug for routes on which you want to enable caching: router.ex pipeline :cache do plug PlugHTTPCache , @caching_options end ... scope &quot;/&quot; , PlugHTTPCacheDemoWeb do pipe_through :browser scope &quot;/some_route&quot; do pipe_through :cache ... end end You can also configure it for all requests by setting it in Phoenix's endpoint file: endpoint.ex defmodule MyApp.Endpoint do use Phoenix.Endpoint , otp_app : :plug_http_cache_demo % some other plugs plug Plug.RequestId plug Plug.Telemetry , event_prefix : [ :phoenix , :endpoint ] plug Plug.Parsers , parsers : [ :urlencoded , :multipart , :json ] , pass : [ &quot;*/*&quot; ] , json_decoder : Phoenix . json_library ( ) plug Plug.Head plug Plug.Session , @session_options plug PlugHTTPCache , @caching_options plug PlugHTTPCacheDemoWeb.Router end Note that: caching chunked responses is not supported some responses (called &quot;cacheable by default&quot;) can be cached even when no cache-control header is set. For instance, a 200 response to a get request is cached 2 minutes by default, unless cache-control headers prohibit it Phoenix automatically sets the &quot;cache-control&quot; header to &quot;max-age=0, private, must-revalidate&quot; , so by default no response will ever be cached unless you override this header You can also configure PlugHTTPCache.StaleIfError to return expired cached responses. This is useful to continue returning something when the backend experiences failures (for example if the DB crashed and while it's rebooting).","ref":"readme.html#configuration","title":"PlugHTTPCache - Configuration","type":"extras"},{"doc":"Plug options are those documented by :http_cache.opts/0 . The only required option is :store . This plug sets the following default options: :type : :shared , :auto_compress : true , :auto_accept_encoding : true","ref":"readme.html#plug-options","title":"PlugHTTPCache - Plug options","type":"extras"},{"doc":"Responses have to be stored in a separate store backend (this library does not come with one), such as: http_cache_store_memory : responses are stored in memory (ETS) http_cache_store_disk : responses are stored on disk. This library uses the sendfile system call and therefore benefits from the kernel's memory caching automatically Both are cluster-aware. To use it along with this library, just add it to your mix.exs file: mix.exs { :plug_http_cache , &quot;~&gt; ...&quot; } , { :http_cache_store_memory , &quot;~&gt; ...&quot; } ,","ref":"readme.html#stores","title":"PlugHTTPCache - Stores","type":"extras"},{"doc":"Unlike many HTTP caches, http_cache allows caching: responses to authorized request (with an &quot;authorization&quot; header) responses with cookies In the first case, beware of authenticating before handling caching. In other words, don't : PlugHTTPCache , @caching_options MyPlug.AuthorizeUser which would return a cached response to unauthorized users, but do instead: MyPlug.AuthorizeUser PlugHTTPCache , @caching_options Beware of not setting caching headers on private responses containing cookies.","ref":"readme.html#security-considerations","title":"PlugHTTPCache - Security considerations","type":"extras"},{"doc":"PlugCacheControl can be used to set cache-control headers in your Plug pipelines, or manually in your controllers PlugHTTPValidator should be used to set HTTP validators as soon as cacheable content is returned. See project documentation to figure out why","ref":"readme.html#useful-libraries","title":"PlugHTTPCache - Useful libraries","type":"extras"},{"doc":"The following events are emitted: [:plug_http_cache, :hit] when a cached response is returned. [:plug_http_cache, :miss] when no cached response was found [:plug_http_cache, :stale_if_error] when a response was returned because an error occurred downstream (see PlugHTTPCache.StaleIfError ) Neither measurements nor metadata are added to these events. The http_cache , http_cache_store_memory and http_cache_store_disk emit other events about the caching subsystems, including some helping with detecting normalization issues.","ref":"readme.html#telemetry-events","title":"PlugHTTPCache - Telemetry events","type":"extras"},{"doc":"The underlying http caching library may store different responses for the same URL, following the directives of the &quot;vary&quot; header. For instance, if a response can be returned in English or in French, both versions can be cached as long as the &quot;vary&quot; header is correctly used. This can unfortunately result in an explosion of stored responses if the headers are not normalized. For instance, in this scenario where a site handles both these languages, a response will be stored for any of these requests that include an &quot;accept-language&quot; header: fr-CH, fr;q=0.9, en;q=0.8, de;q=0.7, *;q=0.5 fr-CH, fr;q=0.9, en;q=0.8, de;q=0.7,*;q=0.5 en de en, de en, de, fr en;q=1, de en;q=1, de;q=0.9 en;q=1, de;q=0.8 en;q=1, de;q=0.7 en;q=1, de;q=0.6 en;q=1, de;q=0.5 and so on, so potentially hundreds of stored responses for only 2 available responses (English and French versions). In this case, you probably want to apply normalization before caching. This could be done by a plug set before the PlugHTTPCache plug. See Best practices for using the Vary header for more guidance regarding this issue.","ref":"readme.html#normalization","title":"PlugHTTPCache - Normalization","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog and this project adheres to Semantic Versioning.","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Changed [ TeslaHTTPCache ] Make http_cache an optional depedency","ref":"changelog.html#0-3-0-2023-06-22","title":"CHANGELOG - [0.3.0] - 2023-06-22","type":"extras"},{"doc":"Changed [ PlugHTTPCache ] Update to use http_cache 0.2.0 [ PlugHTTPCache ] Options are now a map (was previously a keyword list)","ref":"changelog.html#0-2-0-2023-04-25","title":"CHANGELOG - [0.2.0] - 2023-04-25","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0-2022-08-21","title":"CHANGELOG - [0.1.0] - 2022-08-21","type":"extras"}]